package org.foxarmy.barcodescannerforemployees.activities

import android.content.Context
import android.content.SharedPreferences
import android.os.Bundle
import android.view.View
import androidx.appcompat.app.AppCompatActivity
import org.foxarmy.barcodescannerforemployees.Net
import org.foxarmy.barcodescannerforemployees.databinding.ActivityManageGroupBinding
import org.foxarmy.barcodescannerforemployees.parseArray
import org.foxarmy.barcodescannerforemployees.views.GroupMemberView

class ManageGroupActivity : AppCompatActivity(){
    private lateinit var binding: ActivityManageGroupBinding
    private var isAdmin: Boolean = true
    private lateinit var sharedPreferences: SharedPreferences

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        binding = ActivityManageGroupBinding.inflate(layoutInflater)
        setContentView(binding.root)

        val groupId = intent.extras!!.getInt("groupId")

        sharedPreferences = org.foxarmy.barcodescannerforemployees.getPreferences(this)

        val net = Net()

        net.token = sharedPreferences.getString("token", "")!!
        net.server = sharedPreferences.getString("server", "")!!
        net.language = sharedPreferences.getString("language", "en-US")!!


        val users = parseArray(net.getUsersInGroup(groupId).body!!.string())

        for (user in users) {
            val groupMemberView = GroupMemberView(this, this as Context, net.getUsernameById(user).body!!.string(), user)

            binding.groupsContent.addView(groupMemberView)
        }

        isAdmin = amIAnAdminIn(groupId)

        if (!isAdmin) {
            binding.renameButton.visibility = View.GONE
        }
    }

    fun amIAnAdminIn(groupId: Int): Boolean {
        val net = Net()

        net.token = sharedPreferences.getString("token", "")!!
        net.server = sharedPreferences.getString("server", "")!!
        net.language = sharedPreferences.getString("language", "en-US")!!

        val result = sharedPreferences.getInt("userId", 0) == net.getGroupAdminId(groupId).body!!.string().toInt()
        return result
    }
}