package org.foxarmy.barcodescannerforemployees.activities

import android.app.Activity
import android.content.Intent
import android.content.SharedPreferences
import android.os.Bundle

class NavigatorActivity : Activity() {

    private lateinit var sharedPreferences: SharedPreferences

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        sharedPreferences = org.foxarmy.barcodescannerforemployees.getPreferences(this)

        var intent = Intent(this, MainActivity::class.java)

        if (!isInGroup() && !isOffline()) {
            intent = Intent(this, GroupActivity::class.java)
        }

        if (!isAuthenticated() && !isOffline()) {
            intent = Intent(this, LoginActivity::class.java);
        }

        startActivity(intent);
        finish();
    }

    private fun isOffline(): Boolean {
        return sharedPreferences.getString("currentGroup", "")!! == "offline"
    }

    private fun isAuthenticated(): Boolean {
        return sharedPreferences.getString("token", "") != ""
    }

    private fun isInGroup(): Boolean {
        return sharedPreferences.getStringSet("groups", emptySet())!!.isNotEmpty()
    }
}